// SystemMutex.h
//------------------------------------------------------------------------------
#pragma once
#ifndef CORE_PROCESS_SYSTEMMUTEX_H
#define CORE_PROCESS_SYSTEMMUTEX_H

// Includes
//------------------------------------------------------------------------------
#include "Core/Strings/AString.h"

// SystemMutex
//------------------------------------------------------------------------------
class SystemMutex
{
public:
	SystemMutex( const char * );
	~SystemMutex();

	bool TryLock();
	void Unlock();

private:
	#if defined( __WINDOWS__ )
		void * m_Handle;
		#ifdef DEBUG
			bool m_Locked;
		#endif
	#endif
	AString m_Name;
};

//------------------------------------------------------------------------------
#endif // CORE_PROCESS_SYSTEMMUTEX_H
